"""Package that contains utility method and object
@author: T. Cezard
@since: Oct 2 2008
"""
import os, sys, logging,locale
import gzip, bz2
import glob
from threading import Thread


"""initialize the logging with default parameter.
If use several time with same input file only the level of the logging will be change.
@param output_level: The logging level of output for the stdout. If set to None the stdout is not set or not changed. default: INFO.
@param file_level: The logging level of output for the log file. if set to None the logging in a file is not set or not changed. default: INFO.
@param log_file_name: The name of the file used for the logging. if set to None the logging in a file is not set or not changed. default: None.
@param overwrite: if set to true an existing log file will overwritten, otherwise the next logg will be append. default: None.
Example:
init_logging() --> set the stdout only to INFO
init_logging(log_file_name="any_file") --> set the stdout and the log file to INFO
init_logging(output_level=None, log_file_name="any_file") --> set the log file only to INFO don't touch the stdout
"""
all_logging={}
def init_logging(output_level=logging.INFO, file_level=logging.INFO, log_file_name=None, overwrite=False):
    if not all_logging.get("std_out") and output_level!=None:
        #initialize the logging
        console = logging.StreamHandler(sys.stdout)
        console.setLevel(output_level)
        console.setFormatter(logging.Formatter('%(levelname)s %(message)s'))
        logging.getLogger('')
        logging.getLogger('').addHandler(console)
        all_logging["std_out"]=(console,output_level)
        logging.getLogger('').setLevel(logging.NOTSET)
    elif output_level:
        (console,dummy) = all_logging.get("std_out")
        console.setLevel(output_level)
    if log_file_name:
        if not all_logging.get(log_file_name) and file_level!=None:
            ##################
            # bootstrap logfile and set it to the logging environment
            if overwrite:
                logFile = logging.FileHandler(log_file_name, 'w')
            else:
                logFile = logging.FileHandler(log_file_name, 'a')
            logFile.setLevel(file_level)
            logFile.setFormatter(logging.Formatter('%(levelname)s %(message)s'))
            # add the handler to the root logger
            logging.getLogger('').addHandler(logFile)
            all_logging[log_file_name]=(logFile,file_level)
        elif file_level:
            (logFile,dummy)=all_logging.get(log_file_name)
            logFile.setLevel(file_level)


